"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.resolveConfig = void 0;
const path_1 = __importDefault(require("path"));
const cosmiconfig_1 = require("cosmiconfig");
const getCosmiconfig = () => {
    const explorer = (0, cosmiconfig_1.cosmiconfigSync)("neiApi", {
        cache: true,
        transform: (result) => {
            if (result && result.config) {
                if (typeof result.config === "string") {
                    const dir = path_1.default.dirname(result.filepath);
                    const modulePath = require.resolve(result.config, { paths: [dir] });
                    result.config = require(modulePath);
                }
                if (typeof result.config !== "object") {
                    throw new Error("Config is only allowed to be an object, " +
                        `but received ${typeof result.config} in "${result.filepath}"`);
                }
                delete result.config.$schema;
            }
            return result;
        },
        searchPlaces: ["package.json", "neiApi.config.js"],
    });
    return explorer;
};
const getCosmiconfigPrivate = () => {
    const explorer = (0, cosmiconfig_1.cosmiconfigSync)("neiApi", {
        cache: true,
        transform: (result) => {
            if (result && result.config) {
                if (typeof result.config === "string") {
                    const dir = path_1.default.dirname(result.filepath);
                    const modulePath = require.resolve(result.config, { paths: [dir] });
                    result.config = require(modulePath);
                }
                if (typeof result.config !== "object") {
                    throw new Error("Config is only allowed to be an object, " +
                        `but received ${typeof result.config} in "${result.filepath}"`);
                }
                delete result.config.$schema;
            }
            return result;
        },
        searchPlaces: [".neiApi.json", ".neiApi"],
    });
    return explorer;
};
const resolveConfig = () => {
    const { search } = getCosmiconfig();
    const { search: searchPrivate } = getCosmiconfigPrivate();
    const result = search();
    const resultPrivate = searchPrivate();
    const config = {
        ...result?.config,
        ...resultPrivate?.config,
    };
    if (Object.keys(config).length === 0) {
        throw new Error('config is empty');
    }
    return config;
};
exports.resolveConfig = resolveConfig;
//# sourceMappingURL=resolveConfig.js.map